#define EXPORT extern "C" _declspec(dllexport)

#include <net-snmp/net-snmp-config.h>
#define NET_SNMP_SNMPV3_H                   // we don't need SNMPV3 (one include file is missing)
#include <net-snmp/net-snmp-includes.h>

typedef void* HSNMP;   // SNMP handle (like FILE)

const char* readCommunity = "public";       ///< community name for read operations
const char* writeCommunity = "guru";        ///< community name for write operation

char *S_sysMainSwitch = "sysMainSwitch.0";
char *S_fanAirTemperature ="fanAirTemperature.0";

char *S_sensorTemperature[8] = {"sensorTemperature.1",
								"sensorTemperature.2",
								"sensorTemperature.3",
								"sensorTemperature.4",
								"sensorTemperature.5",
								"sensorTemperature.6",
								"sensorTemperature.7",
								"sensorTemperature.8"};


char *S_outputMeasurementSenseVoltageBase = "outputMeasurementSenseVoltage.";
char *S_outputMeasurementSenseVoltage[320];

char *S_outputMeasurementCurrentBase ="outputMeasurementCurrent.";
char *S_outputMeasurementCurrent[320];

char *S_outputVoltageBase ="outputVoltage.";
char *S_outputVoltage[320];

char *S_outputRiseRateBase ="outputVoltageRiseRate.";
char *S_outputRiseRate[320];

char *S_outputFallRateBase ="outputVoltageFallRate.";
char *S_outputFallRate[320];

char *S_outputStatusBase = "outputStatus.1";
char *S_outputStatus[320];

char *S_outputSwitchBase = "outputSwitch.1";
char *S_outputSwitch[320];

oid oidSysMainSwitch [MAX_OID_LEN];
size_t lengthSysMainSwitch;
oid oidOutputMeasurementSenseVoltageAll [MAX_OID_LEN];
size_t lengthOutputMeasurementSenseVoltageAll;
oid oidFanAirTemperature[MAX_OID_LEN];
size_t lengthFanAirTemperature;
oid oidSensorTemperature  [8] [MAX_OID_LEN];
size_t lengthSensorTemperature[8];
oid oidOutputMeasurementSenseVoltage[320] [MAX_OID_LEN];
size_t lengthOutputMeasurementSenseVoltage[320];
oid oidOutputVoltage[320] [MAX_OID_LEN];
size_t lengthOutputVoltage[320];
oid oidOutputMeasurementCurrent[320] [MAX_OID_LEN];
size_t lengthOutputMeasurementCurrent[320];
oid oidOutputRiseRate[320] [MAX_OID_LEN];
size_t lengthOutputRiseRate[320];
oid oidOutputFallRate[320] [MAX_OID_LEN];
size_t lengthOutputFallRate[320];
oid oidOutputStatus[320] [MAX_OID_LEN];
size_t lengthOutputStatus[320];
oid oidChannelSwitch[320] [MAX_OID_LEN];
size_t lengthChannelSwitch[320];



// DLL functions

void __stdcall syslog(int priority,const char* format,...);
int __stdcall SnmpInit(void);
void __stdcall SnmpCleanup(void);
HSNMP __stdcall SnmpOpen(const char* ipAddress);
void __stdcall SnmpClose(HSNMP m_sessp);

double __stdcall getOutputVoltage(HSNMP m_sessp,int channel);
double __stdcall setOutputVoltage(HSNMP m_sessp,int channel,double value);
double __stdcall getCurrentMeasurement(HSNMP m_sessp, int channel);
double __stdcall getOutputSenseMeasurement(HSNMP m_sessp, int channel);
double __stdcall getOutputRiseRate(HSNMP m_sessp,int channel);
double __stdcall setOutputRiseRate(HSNMP m_sessp,int channel,double value);
double __stdcall getOutputFallRate(HSNMP m_sessp,int channel);
double __stdcall setOutputFallRate(HSNMP m_sessp,int channel,double value);
int __stdcall getMainSwitch(HSNMP m_sessp);
int __stdcall setMainSwitch(HSNMP m_sessp, int value);
int __stdcall getChannelStatus(HSNMP m_sessmp, int channel);
int __stdcall setChannelSwitch(HSNMP m_sessmp, int channel, int value);
int __stdcall getChannelSwitch(HSNMP m_sessmp, int channel);
int __stdcall getFantrayTemp(HSNMP m_sessp);
int __stdcall getSensorTemp(HSNMP m_sessp, int sensor);

double __stdcall snmpSetDouble(HSNMP m_sessp, const oid* parameter, size_t length, double value);
double __stdcall snmpGetDouble(HSNMP m_sessp, const oid* parameter, size_t length);
int __stdcall snmpSetInt(HSNMP m_sessp, const oid* parameter, size_t length, int value);
int __stdcall snmpGetInt(HSNMP m_sessp, const oid* parameter, size_t length);