/** WIENER SNMP basic SNMP library to Demonstrate C-Access to WIENER-Crates via SNMP
// modified for LabView imprt 04/23/06, Andreas Ruben
//
// The path to the Net-SNMP include files (default /usr/include) must be added to the 
// include file search path!
// The following libraries must be included:
// netsnmp.lib ws2_32.lib
// The path to the Net-SNMP library must be added to the linker files.
// /usr/lib
// path for the WIENER MIB file (mibdirs) c:/usr/share/snmp/mibs
*/
#include "stdafx.h"
#include "WIENER_SNMP.h"
#define WIN32_LEAN_AND_MEAN     // Exclude rarely-used stuff from Windows headers
//#include <windows.h>


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{
    return TRUE;
}

/******************************************************************************/
/** simple syslog replacement for this example.
*/
void __stdcall syslog(int priority,const char* format,...) {
  va_list vaPrintf; 
  va_start(vaPrintf,format);
  vprintf(format,vaPrintf); putchar('\n');
  va_end(vaPrintf);
}

/******************************************************************************/
/** SNMP Initialization.
*/


int __stdcall SnmpInit(void) {
	syslog(LOG_DEBUG,"*** Initialise SNMP ***");

  init_snmp("CrateTest");									  // I never saw this name used !?!
	init_mib();																// init MIB processing
  if(!read_module("WIENER-CRATE-MIB")) {		// read specific mibs
    syslog(LOG_ERR,"Unable to load SNMP MIB file \"%s\"","WIENER-CRATE-MIB");
    return 0;
  }
  syslog(LOG_DEBUG,"*** Translate OIDs ***");

//Translate System OIDS
  lengthSysMainSwitch = MAX_OID_LEN;
  if(!get_node(S_sysMainSwitch,oidSysMainSwitch,&lengthSysMainSwitch)) {
		syslog(LOG_ERR,"OID \"sysMainSwitch.0\"not found"); return false; } 

  lengthSysStatus = MAX_OID_LEN;
  if(!get_node(S_sysStatus,oidSysStatus,&lengthSysStatus)) {
		syslog(LOG_ERR,"OID \"sysStatus.0\"not found"); return false;} 

  lengthSysVmeSysReset = MAX_OID_LEN;
  if(!get_node(S_sysVmeSysReset,oidSysVmeSysReset,&lengthSysVmeSysReset)) {
		syslog(LOG_ERR,"OID \"SysVmeSysReset.0\"not found"); return false;} 



//Translate System Channel Count Information OIDS
  lengthOutputNumber = MAX_OID_LEN;
  if(!get_node(S_outputNumber,oidOutputNumber,&lengthOutputNumber)) {
		syslog(LOG_ERR,"OID \"OutputNumber.0\"not found"); return false; } 

  lengthGroupsNumber = MAX_OID_LEN;
  if(!get_node(S_groupsNumber,oidGroupsNumber,&lengthGroupsNumber)) {
		syslog(LOG_ERR,"OID \"groupsNumber.0\"not found"); return false;} 


//Translate Channel Information OIDS


  char s[100];
  char index[4];
  int base =0;
  int indexBase=0;
  int j=0;

  for( int i = 0; i < 2; i++) {
	base = 32*i;
	indexBase = 100*i;
    for( j = 1; j < 33; j++)
    {
	  strcpy(s, S_outputNameBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  printf("%s\n", s);
	  lengthOutputName[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputName[base+j],&lengthOutputName[base+j])) {
	 	syslog(LOG_ERR,"OID \"outputName\"not found"); return false;}

	  strcpy(s, S_outputGroupBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputGroup[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputGroup[base+j],&lengthOutputGroup[base+j])) {
	 	syslog(LOG_ERR,"OID \"OutputGroup\"not found"); return false;}

      strcpy(s, S_outputStatusBase);
	  sprintf(index, "%i",indexBase+j);
	  strcat(s, index);
	  lengthOutputStatus[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputStatus[base+j],&lengthOutputStatus[base+j])) {
		syslog(LOG_ERR,"OID \"outputStatus.1\"not found"); return false; } 

	  strcpy(s, S_outputMeasurementSenseVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputMeasurementSenseVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputMeasurementSenseVoltage[base+j],&lengthOutputMeasurementSenseVoltage[base+j])) {
	 	syslog(LOG_ERR,"OID \"outputMeasurementSenseVoltage.1\"not found"); return false;}

	  strcpy(s, S_outputMeasurementTerminalVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputMeasurementTerminalVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputMeasurementTerminalVoltage[base+j],&lengthOutputMeasurementTerminalVoltage[base+j])) {
	 	syslog(LOG_ERR,"OID \"outputMeasurementTerminalVoltage.1\"not found"); return false;}

	  strcpy(s, S_outputMeasurementCurrentBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputMeasurementCurrent[base+j] = MAX_OID_LEN;
		if(!get_node(s,oidOutputMeasurementCurrent[base+j],&lengthOutputMeasurementCurrent[base+j])) {
			syslog(LOG_ERR,"OID \"outputMeasurementCurrent.1\"not found"); return false; }

	  strcpy(s, S_outputMeasurementTemperatureBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputMeasurementTemperature[base+j] = MAX_OID_LEN;
		if(!get_node(s,oidOutputMeasurementTemperature[base+j],&lengthOutputMeasurementTemperature[base+j])) {
			syslog(LOG_ERR,"OID \"outputMeasurementTemperature\"not found"); return false; }
    
	  strcpy(s, S_outputSwitchBase);
	  sprintf(index, "%i",indexBase+j);
	  strcat(s, index);
	  lengthChannelSwitch[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidChannelSwitch[base+j],&lengthChannelSwitch[base+j])) {
		syslog(LOG_ERR,"OID \"channelSwitch.1\"not found"); return false;  } 

	  strcpy(s, S_outputVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputVoltage[base+j],&lengthOutputVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputVoltage.1\"not found"); return false; }

	  strcpy(s, S_outputCurrentBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputCurrent[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputCurrent[base+j],&lengthOutputCurrent[base+j])) {
		syslog(LOG_ERR,"OID \"outputCurrent\"not found"); return false; }

	  strcpy(s, S_outputRiseRateBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputRiseRate[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputRiseRate[base+j],&lengthOutputRiseRate[base+j])) {
		syslog(LOG_ERR,"OID \"outputRiseRate.1\"not found"); return false;} 
	
	  strcpy(s, S_outputFallRateBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputFallRate[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputFallRate[base+j],&lengthOutputFallRate[base+j])) {
		syslog(LOG_ERR,"OID \"outputRiseRate.1\"not found"); return false; } 
	
	  strcpy(s, S_outputSupervisionBehaviorBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionBehavior[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionBehavior[base+j],&lengthOutputSupervisionBehavior[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionBehavior\"not found"); return false; } 
	
	  strcpy(s, S_outputSupervisionMinSenseVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionMinSenseVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionMinSenseVoltage[base+j],&lengthOutputSupervisionMinSenseVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionMinSenseVoltage\"not found"); return false; } 

	  strcpy(s, S_outputSupervisionMaxSenseVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionMaxSenseVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionMaxSenseVoltage[base+j],&lengthOutputSupervisionMaxSenseVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionMaxSenseVoltage\"not found"); return false; } 

	  strcpy(s, S_outputSupervisionMaxTerminalVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionMaxTerminalVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionMaxTerminalVoltage[base+j],&lengthOutputSupervisionMaxTerminalVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionMaxTerminalVoltage\"not found"); return false; } 

	  strcpy(s, S_outputSupervisionMaxCurrentBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionMaxCurrent[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionMaxCurrent[base+j],&lengthOutputSupervisionMaxCurrent[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionMaxCurrent\"not found"); return false; } 
/*
	  strcpy(s, S_outputSupervisionMaxTemperatureBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputSupervisionMaxTemperature[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputSupervisionMaxTemperature[base+j],&lengthOutputSupervisionMaxTemperature[base+j])) {
		syslog(LOG_ERR,"OID \"outputSupervisionMaxTemperature\"not found"); return false; } 
*/
	  strcpy(s, S_outputConfigMaxSenseVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputConfigMaxSenseVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputConfigMaxSenseVoltage[base+j],&lengthOutputConfigMaxSenseVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputConfigMaxSenseVoltage\"not found"); return false; } 

	  strcpy(s, S_outputConfigMaxTerminalVoltageBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputConfigMaxTerminalVoltage[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputConfigMaxTerminalVoltage[base+j],&lengthOutputConfigMaxTerminalVoltage[base+j])) {
		syslog(LOG_ERR,"OID \"outputConfigMaxTerminalVoltage\"not found"); return false; }
	  
	  strcpy(s, S_outputConfigMaxCurrentBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputConfigMaxCurrent[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputConfigMaxCurrent[base+j],&lengthOutputConfigMaxCurrent[base+j])) {
		syslog(LOG_ERR,"OID \"outputConfigMaxCurrent\"not found"); return false; }

	  strcpy(s, S_outputConfigMaxPowerBase);
	  sprintf(index, "%i", indexBase+j);
	  strcat(s, index);
	  lengthOutputConfigMaxPower[base+j] = MAX_OID_LEN;
	  if(!get_node(s,oidOutputConfigMaxPower[base+j],&lengthOutputConfigMaxPower[base+j])) {
		syslog(LOG_ERR,"OID \"outputConfigMaxPower\"not found"); return false; }
	}  
  } 


//Sensor Information
  lengthSensorNumber = MAX_OID_LEN;
  if(!get_node(S_sensorNumber,oidSensorNumber,&lengthSensorNumber)) {
		syslog(LOG_ERR,"OID \"SensorNumber.0\"not found"); return false;} 

  for(int j = 0; j < 8; j++)
  {
	strcpy(s, S_sensorTemperatureBase);
	sprintf(index, "%i", j+1);
	strcat(s, index);
	lengthSensorTemperature[j] = MAX_OID_LEN;
	if(!get_node(s,oidSensorTemperature[j],&lengthSensorTemperature[j])) {
		syslog(LOG_ERR,"OID \"sensorTemperature.0\"not found"); return false; } 

	strcpy(s, S_sensorWarningThresholdBase);
	sprintf(index, "%i", j+1);
	strcat(s, index);
	lengthSensorWarningThreshold[j] = MAX_OID_LEN;
	if(!get_node(s,oidSensorWarningThreshold[j],&lengthSensorWarningThreshold[j])) {
		syslog(LOG_ERR,"OID \"WarningThreshold\"not found"); return false; } 

	strcpy(s, S_sensorFailureThresholdBase);
	sprintf(index, "%i", j+1);
	strcat(s, index);
	lengthSensorFailureThreshold[j] = MAX_OID_LEN;
	if(!get_node(s,oidSensorFailureThreshold[j],&lengthSensorFailureThreshold[j])) {
		syslog(LOG_ERR,"OID \"FailureThreshold\"not found"); return false; } 
  }


//Translate SNMP community Name OIDs
  for(int j = 0; j < 4; j++)
  {
	strcpy(s, S_snmpCommunityNameBase);
	sprintf(index, "%i", j+1);
	strcat(s, index);
	lengthSnmpCommunityName[j] = MAX_OID_LEN;
	if(!get_node(s,oidSnmpCommunityName[j],&lengthSnmpCommunityName[j])) {
		syslog(LOG_ERR,"OID \"smpCommunityNameBase\"not found"); return false; } 
  }


//Translate PS Specific OIDs
/*
  lengthPsFirmwareVersion = MAX_OID_LEN;
  if(!get_node(S_psFirmwareVersion,oidPsFirmwareVersion,&lengthPsFirmwareVersion)) {
		syslog(LOG_ERR,"OID \"psFirmwareRevision\"not found"); return false; } 
*/
  lengthPsSerialNumber = MAX_OID_LEN;
  printf("\nPs Serial Number: %s\n", S_psSerialNumber);
  if(!get_node(S_psSerialNumber,oidPsSerialNumber,&lengthPsSerialNumber)) {
		syslog(LOG_ERR,"OID \"psSerialNumber\"not found"); return false; } 

  lengthPsOperatingTime = MAX_OID_LEN;
  if(!get_node(S_psOperatingTime,oidPsOperatingTime,&lengthPsOperatingTime)) {
		syslog(LOG_ERR,"OID \"PsOperatingTime\"not found"); return false; } 

  lengthPsDirectAccess = MAX_OID_LEN;
  if(!get_node(S_psDirectAccess,oidPsDirectAccess,&lengthPsDirectAccess)) {
		syslog(LOG_ERR,"OID \"PsDirectAccess\"not found"); return false; } 

/*
//Translate Fan Tray OIDs
  lengthFanFirmwareVersion = MAX_OID_LEN;
  if(!get_node(S_fanFirmwareVersion,oidFanFirmwareVersion,&lengthFanFirmwareVersion)) {
		syslog(LOG_ERR,"OID \"FanFirmwareVersion\"not found"); return false; } 
*/
  lengthFanSerialNumber = MAX_OID_LEN;
  if(!get_node(S_fanSerialNumber,oidFanSerialNumber,&lengthFanSerialNumber)) {
		syslog(LOG_ERR,"OID \"FanSerialNumber\"not found"); return false; } 

  lengthFanOperatingTime = MAX_OID_LEN;
  if(!get_node(S_fanOperatingTime,oidFanOperatingTime,&lengthFanOperatingTime)) {
		syslog(LOG_ERR,"OID \"FanOperatingTime\"not found"); return false; } 

  lengthFanAirTemperature = MAX_OID_LEN;
  if(!get_node(S_fanAirTemperature,oidFanAirTemperature,&lengthFanAirTemperature)) {
		syslog(LOG_ERR,"OID \"fanAirTemperature.0\"not found"); return false; } 

  lengthFanSwitchOffDelay = MAX_OID_LEN;
  if(!get_node(S_fanSwitchOffDelay,oidFanSwitchOffDelay,&lengthFanSwitchOffDelay)) {
		syslog(LOG_ERR,"OID \"FanSwitchOffDelay\"not found"); return false; } 

  lengthFanNominalSpeed = MAX_OID_LEN;
  if(!get_node(S_fanNominalSpeed,oidFanNominalSpeed,&lengthFanNominalSpeed)) {
		syslog(LOG_ERR,"OID \"FanNominalSpeed\"not found"); return false; } 

  lengthFanNumberOfFans = MAX_OID_LEN;
  if(!get_node(S_fanNumberOfFans,oidFanNumberOfFans,&lengthFanNumberOfFans)) {
		syslog(LOG_ERR,"OID \"NumberOfFans\"not found"); return false; } 

  for(int j = 0; j < 6; j++)
  {
	strcpy(s, S_fanSpeedBase);
	sprintf(index, "%i", j+1);
	strcat(s, index);
	lengthFanSpeed[j] = MAX_OID_LEN;
	if(!get_node(s,oidFanSpeed[j],&lengthFanSpeed[j])) {
		syslog(LOG_ERR,"OID \"FanSpeed\"not found"); return false; } 
  }

  syslog(LOG_DEBUG,"*** Initialise SNMP done ***");
  SOCK_STARTUP;															// only in main thread
  return 1;
}

/******************************************************************************/
/** SNMP Cleanup.
*/
void __stdcall SnmpCleanup(void) {
	SOCK_CLEANUP;
}


/******************************************************************************/
/** SNMP Open Session.
*/
//typedef void* HSNMP;                              // SNMP handle (like FILE)

HSNMP __stdcall SnmpOpen(const char* ipAddress) {
	HSNMP m_sessp;
  struct snmp_session session;
  snmp_sess_init(&session);			                  // structure defaults
  session.version = SNMP_VERSION_2c;
  session.peername = strdup(ipAddress);
  session.community = (u_char*)strdup(readCommunity);
  session.community_len = strlen((char*)session.community);

  session.timeout = 100000;   // timeout (us)
  session.retries = 3;        // retries

  if(!(m_sessp = snmp_sess_open(&session))) {
    int liberr, syserr;
    char *errstr;
    snmp_error(&session, &liberr, &syserr, &errstr);
    syslog(LOG_ERR,"Open SNMP session for host \"%s\": %s",ipAddress,errstr);
    free(errstr);
    return 0;
  }

//  m_session = snmp_sess_session(m_sessp);     // get the session pointer 

  syslog(LOG_INFO,"SNMP session for host \"%s\" opened",ipAddress);
  return m_sessp;
}

/******************************************************************************/
/** SNMP Close Session.
*/
void __stdcall SnmpClose(HSNMP m_sessp) {
  if(!m_sessp) return;
  if(!snmp_sess_close(m_sessp)) {
    syslog(LOG_ERR,"Close SNMP session: ERROR");
  }
  else syslog(LOG_INFO,"SNMP session closed");
}



//System Information Functions


/******************************************************************************/
/** Get on/off status of crate
*/
int __stdcall getMainSwitch(HSNMP m_sessp) {
	int value = snmpGetInt(m_sessp, oidSysMainSwitch, lengthSysMainSwitch);
	return value;
}

/******************************************************************************/
/** Write on/off status
*/
int  __stdcall setMainSwitch(HSNMP m_sessp,int value) {
  	value = snmpSetInt(m_sessp, oidSysMainSwitch, lengthSysMainSwitch, value);
	return value;
}

/******************************************************************************/
/** Get Main Status
*/
int __stdcall getMainStatus(HSNMP m_sessp){
	int value = snmpGetInt(m_sessp, oidSysStatus, lengthSysStatus);
	return value;
}

/******************************************************************************/
/** Get VmeReset Status
*/
int __stdcall getVmeReset(HSNMP m_sessp){
	int value = snmpGetInt(m_sessp, oidSysVmeSysReset, lengthSysVmeSysReset);
	return value;
}

/******************************************************************************/
/** Initiate VME SysReset
*/
int __stdcall setVmeReset(HSNMP m_sessp){
  	int value = snmpSetInt(m_sessp, oidSysVmeSysReset, lengthSysVmeSysReset, 1);
	return value;
}



//System Count Functions

/******************************************************************************/
/** Get the number of channels from power supply
*/
int __stdcall getOutputNumber(HSNMP m_sessp){
	int value = snmpGetInt(m_sessp, oidOutputNumber, lengthOutputNumber);
	return value;
}

/******************************************************************************/
/** Get the number of channels from power supply
*/
int __stdcall getOutputGroups(HSNMP m_sessp){
	int value = snmpGetInt(m_sessp, oidGroupsNumber, lengthGroupsNumber);
	return value;
}




//Output Channel Information

/******************************************************************************/
/** I Don't know yet how to set this up
*/
//std::string __stdcall getOutputName(HSNMP m_sessp,int channel);

int __stdcall getOutputGroup(HSNMP m_sessp,int channel){
	int value = snmpGetInt(m_sessp, oidOutputGroup[channel], lengthOutputGroup[channel]);
	return value; }

int __stdcall getChannelStatus(HSNMP m_sessp, int channel){
	int value = snmpGetInt(m_sessp, oidOutputStatus[channel], lengthOutputStatus[channel]);
	return value; }

double __stdcall getOutputSenseMeasurement(HSNMP m_sessp, int channel){
	double value = snmpGetDouble(m_sessp, oidOutputMeasurementSenseVoltage[channel], 
		                   lengthOutputMeasurementSenseVoltage[channel]);
	return value; }

double __stdcall getOutputTerminalMeasurement(HSNMP m_sessp, int channel){
	double value = snmpGetDouble(m_sessp, oidOutputMeasurementTerminalVoltage[channel], 
		                   lengthOutputMeasurementTerminalVoltage[channel]);
	return value; }

double __stdcall getCurrentMeasurement(HSNMP m_sessp, int channel){
	double value = snmpGetDouble(m_sessp, oidOutputMeasurementCurrent[channel], 
		                   lengthOutputMeasurementCurrent[channel]);
	return value; }

int __stdcall getTemperatureMeasurement(HSNMP m_sessp, int channel){
	int value = snmpGetInt(m_sessp, oidOutputMeasurementTemperature[channel], 
		                   lengthOutputMeasurementTemperature[channel]);
	return value; }

int __stdcall setChannelSwitch(HSNMP m_sessp, int channel,int value) {
  	value = snmpSetInt(m_sessp, oidChannelSwitch[channel], 
						   lengthChannelSwitch[channel], value);
	return value; }

int __stdcall getChannelSwitch(HSNMP m_sessmp, int channel){
  	int value = snmpGetInt(m_sessmp, oidChannelSwitch[channel], 
						   lengthChannelSwitch[channel]);
	return value; }

double __stdcall getOutputVoltage(HSNMP m_sessp, int channel) {
    double value = snmpGetDouble(m_sessp, oidOutputVoltage[channel],
	                           lengthOutputVoltage[channel] );
  return value; }

double __stdcall setOutputVoltage(HSNMP m_sessp, int channel, double value) {
	value = snmpSetDouble(m_sessp, oidOutputVoltage[channel],
	                      lengthOutputVoltage[channel], value );
	return value; }

double __stdcall getOutputCurrent(HSNMP m_sessp,int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputCurrent[channel],
	                      lengthOutputCurrent[channel]);
	return value; }

double __stdcall setOutputCurrent(HSNMP m_sessp,int channel,double value){
	value = snmpSetDouble(m_sessp, oidOutputCurrent[channel],
	                      lengthOutputCurrent[channel], value );
	return value; }

double __stdcall getOutputRiseRate(HSNMP m_sessp, int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputRiseRate[channel],
	                           lengthOutputRiseRate[channel] );
	return value; }

double  __stdcall setOutputRiseRate(HSNMP m_sessp,int channel,double value) {
	value = snmpSetDouble(m_sessp, oidOutputRiseRate[channel],
	                      lengthOutputRiseRate[channel], value );
	return value; }

double __stdcall getOutputFallRate(HSNMP m_sessp, int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputFallRate[channel],
	                           lengthOutputFallRate[channel] );
	return value; }

double  __stdcall setOutputFallRate(HSNMP m_sessp,int channel,double value) {
	value = snmpSetDouble(m_sessp, oidOutputFallRate[channel],
	                           lengthOutputFallRate[channel], value );
	return value; }

int __stdcall getOutputSupervisionBehavior(HSNMP m_sessp,int channel) {
	int value = snmpGetInt(m_sessp, oidOutputSupervisionBehavior[channel],
	                           lengthOutputSupervisionBehavior[channel] );
	return value; }

int __stdcall setOutputSupervisionBehavior(HSNMP m_sessp,int channel,int value) {
	value = snmpSetInt(m_sessp, oidOutputSupervisionBehavior[channel],
	                           lengthOutputSupervisionBehavior[channel], value );
	return value; }

double __stdcall getOutputSupervisionMinSenseVoltage(HSNMP m_sessp,int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputSupervisionMinSenseVoltage[channel],
	                           lengthOutputSupervisionMinSenseVoltage[channel] );
	return value; }

double __stdcall setOutputSupervisionMinSenseVoltage(HSNMP m_sessp,int channel,double value) {
	value = snmpSetDouble(m_sessp, oidOutputSupervisionMinSenseVoltage[channel],
	                           lengthOutputSupervisionMinSenseVoltage[channel], value );
	return value; }

double __stdcall getOutputSupervisionMaxSenseVoltage(HSNMP m_sessp,int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputSupervisionMaxSenseVoltage[channel],
	                           lengthOutputSupervisionMaxSenseVoltage[channel] );
	return value; }

double __stdcall setOutputSupervisionMaxSenseVoltage(HSNMP m_sessp,int channel,double value) {
	value = snmpSetDouble(m_sessp, oidOutputSupervisionMaxSenseVoltage[channel],
	                           lengthOutputSupervisionMaxSenseVoltage[channel], value );
	return value; }

double __stdcall getOutputSupervisionMaxTerminalVoltage(HSNMP m_sessp,int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputSupervisionMaxTerminalVoltage[channel],
	                           lengthOutputSupervisionMaxTerminalVoltage[channel] );
	return value; }

double __stdcall setOutputSupervisionMaxTerminalVoltage(HSNMP m_sessp,int channel,double value) {
	value = snmpSetDouble(m_sessp, oidOutputSupervisionMaxTerminalVoltage[channel],
	                           lengthOutputSupervisionMaxTerminalVoltage[channel], value );
	return value; }

double __stdcall getOutputSupervisionMaxCurrent(HSNMP m_sessp,int channel) {
	double value = snmpGetDouble(m_sessp, oidOutputSupervisionMaxCurrent[channel],
	                           lengthOutputSupervisionMaxCurrent[channel] );
	return value; }

double __stdcall setOutputSupervisionMaxCurrent(HSNMP m_sessp,int channel,double value){
	value = snmpSetDouble(m_sessp, oidOutputSupervisionMaxCurrent[channel],
	                           lengthOutputSupervisionMaxCurrent[channel], value );
	return value; }

int __stdcall getOutputSupervisionMaxTemperature(HSNMP m_sessp,int channel) {
	int value = snmpGetInt(m_sessp, oidOutputSupervisionMaxTemperature[channel],
	                           lengthOutputSupervisionMaxTemperature[channel] );
	return value; }


double __stdcall getOutputConfigMaxSenseVoltage(HSNMP m_sessp,int channel)  {
	double value = snmpGetInt(m_sessp, oidOutputConfigMaxSenseVoltage[channel],
	                           lengthOutputConfigMaxSenseVoltage[channel] );
	return value; }

double __stdcall getOutputConfigMaxTerminalVoltage(HSNMP m_sessp,int channel) {
	double value = snmpGetInt(m_sessp, oidOutputConfigMaxTerminalVoltage[channel],
	                           lengthOutputConfigMaxTerminalVoltage[channel] );
	return value; }

double __stdcall getOutputConfigMaxCurrent(HSNMP m_sessp,int channel) {
	double value = snmpGetInt(m_sessp, oidOutputConfigMaxCurrent[channel],
	                           lengthOutputConfigMaxCurrent[channel] );
	return value; }

double __stdcall getOutputConfigMaxPower(HSNMP m_sessp,int channel){
	double value = snmpGetInt(m_sessp, oidOutputConfigMaxPower[channel],
	                           lengthOutputConfigMaxPower[channel] );
	return value; }




//Sensor Information functions
int __stdcall getSensorNumber(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidSensorNumber,
	                           lengthSensorNumber);
	return (int)value; }

int __stdcall getSensorTemp(HSNMP m_sessp, int sensor) {
	double value = snmpGetInt(m_sessp, oidSensorTemperature[sensor],
	                           lengthSensorTemperature[sensor]);
	return (int)value; }

int __stdcall getSensorWarningTemperature(HSNMP m_sessp,int sensor) {
	double value = snmpGetInt(m_sessp, oidSensorWarningThreshold[sensor],
	                           lengthSensorWarningThreshold[sensor]);
	return (int)value; }

int __stdcall setSensorWarningTemperature(HSNMP m_sessp,int sensor,int value){
	 value = snmpSetInt(m_sessp, oidSensorWarningThreshold[sensor],
	                           lengthSensorWarningThreshold[sensor], value);
	return (int)value; }

int __stdcall getSensorFailureTemperature(HSNMP m_sessp,int sensor) {
	double value = snmpGetInt(m_sessp, oidSensorFailureThreshold[sensor],
	                           lengthSensorFailureThreshold[sensor]);
	return (int)value; }

int __stdcall setSensorFailureTemperature(HSNMP m_sessp,int sensor,int value){
	value = snmpSetInt(m_sessp, oidSensorFailureThreshold[sensor],
	                           lengthSensorFailureThreshold[sensor], value);
	return (int)value; }



//Power Supply specific Functions.  
int __stdcall getPsOperatingTime(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidPsOperatingTime,
	                           lengthPsOperatingTime);
	return (int)value; }


//Fan Tray Functions
//std::string __stdcall getFanFirmwareVersion(HSNMP m_sessp);
//std::string __stdcall getFanSerialNumber(HSNMP m_sessp);
int __stdcall getFanOperatingTime(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidFanOperatingTime,
	                           lengthFanOperatingTime );
	return (int)value; } 

int __stdcall getFanAirTemperature(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidFanAirTemperature,
	                           lengthFanAirTemperature );
	return (int)value; } 

int __stdcall getFanSwitchOffDelay(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidFanSwitchOffDelay,
	                           lengthFanSwitchOffDelay );
	return (int)value; } 

int __stdcall setFanSwitchOffDelay(HSNMP m_sessp, int value) {
	value = snmpSetInt(m_sessp, oidFanSwitchOffDelay,
	                           lengthFanSwitchOffDelay, value );
	return (int)value; } 

int __stdcall getFanNominalSpeed(HSNMP m_sessp) {
	double value = snmpGetInt(m_sessp, oidFanNominalSpeed,
	                           lengthFanNominalSpeed );
	return (int)value; } 

int __stdcall setFanNominalSpeed(HSNMP m_sessp, int value){
	value = snmpSetInt(m_sessp, oidFanNominalSpeed,
	                           lengthFanNominalSpeed, value );
	return (int)value; } 

int __stdcall getFanNumberOfFans(HSNMP m_sessp){
	double value = snmpGetInt(m_sessp, oidFanNumberOfFans,
	                           lengthFanNumberOfFans );
	return (int)value; } 

int __stdcall getFanSpeed(HSNMP m_sessp, int fan) {
	double value = snmpGetInt(m_sessp, oidFanSpeed[fan],
	                           lengthFanSpeed[fan]);
	return (int)value; } 



//The rest of the functions are utility functions that actually do the SNMP calls

int __stdcall snmpGetInt(HSNMP m_sessp, const oid* parameter, size_t length) {
  double value;

  struct snmp_pdu* pdu = snmp_pdu_create(SNMP_MSG_GET);    // prepare get-request pdu

  // for(each GET request to one crate) {
    snmp_add_null_var(pdu,parameter,length);   // generate request data
  // } // endfor

  struct snmp_pdu* response;
	int status = snmp_sess_synch_response(m_sessp,pdu,&response);

  /*
  * Process the response.
  */
  if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
    /*
    * SUCCESS: Print the result variables
    */
    struct variable_list *vars;

    /* manipuate the information ourselves */
    for(vars = response->variables; vars; vars = vars->next_variable) {
			if (vars->type == ASN_OPAQUE_FLOAT) {				    // 0x78
        value = *vars->val.floatVal;
      }
			else if (vars->type == ASN_OPAQUE_DOUBLE) {			// 0x79
        value = *vars->val.doubleVal;
      }
			else if(vars->type == ASN_INTEGER) {				      // 0x02
				value = (double)*vars->val.integer;
      }
    }
  } else {
    /*
    * FAILURE: print what went wrong!
    */

    if (status == STAT_SUCCESS)
      fprintf(stderr, "Error in packet\nReason: %s\n",
      snmp_errstring(response->errstat));
    else
      snmp_sess_perror("snmpget",snmp_sess_session(m_sessp));
    return 0;
  }
  snmp_free_pdu(response);
  return (int) value;
}



int __stdcall snmpSetInt(HSNMP m_sessp, const oid* parameter, size_t length, int value) {
  struct snmp_pdu* pdu = snmp_pdu_create(SNMP_MSG_SET);    // prepare set-request pdu
  pdu->community = (u_char*)strdup(writeCommunity);
  pdu->community_len = strlen(writeCommunity);

  // for(each SET request to one crate) {
  int v = (int) value;
  snmp_pdu_add_variable(pdu,parameter,length,ASN_INTEGER,(u_char*)&v,sizeof(v));
  // } // endfor
  value=v;
  struct snmp_pdu* response;
	int status = snmp_sess_synch_response(m_sessp,pdu,&response);

  /*
  * Process the response.
  */
  if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
    /*
    * SUCCESS: Print the result variables
    */
    struct variable_list *vars;
    
    // debug print
    //for(vars = response->variables; vars; vars = vars->next_variable)
    //  print_variable(vars->name, vars->name_length, vars);

    /* manipuate the information ourselves */
    for(vars = response->variables; vars; vars = vars->next_variable) {
			if (vars->type == ASN_OPAQUE_FLOAT) {				    // 0x78
        value = (int)*vars->val.floatVal;
      }
			else if (vars->type == ASN_OPAQUE_DOUBLE) {			// 0x79
        value = (int)*vars->val.doubleVal;
      }
			else if(vars->type == ASN_INTEGER) {				      // 0x02
				value = *vars->val.integer;
      }
    }
  } else {
    /*
    * FAILURE: print what went wrong!
    */

    if (status == STAT_SUCCESS)
      fprintf(stderr, "Error in packet\nReason: %s\n",
      snmp_errstring(response->errstat));
    else
      snmp_sess_perror("snmpget",snmp_sess_session(m_sessp));
    return 0;
  }
  snmp_free_pdu(response);
  return (int) value;
}



double __stdcall snmpGetDouble(HSNMP m_sessp, const oid* parameter, size_t length) {
  double value;

  struct snmp_pdu* pdu = snmp_pdu_create(SNMP_MSG_GET);    // prepare get-request pdu

  // for(each GET request to one crate) {
    snmp_add_null_var(pdu,parameter,length);   // generate request data
  // } // endfor

  struct snmp_pdu* response;
	int status = snmp_sess_synch_response(m_sessp,pdu,&response);

  /*
  * Process the response.
  */
  if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
    /*
    * SUCCESS: Print the result variables
    */
    struct variable_list *vars;

    /* manipuate the information ourselves */
    for(vars = response->variables; vars; vars = vars->next_variable) {
			if (vars->type == ASN_OPAQUE_FLOAT) {				    // 0x78
        value = *vars->val.floatVal;
      }
			else if (vars->type == ASN_OPAQUE_DOUBLE) {			// 0x79
        value = *vars->val.doubleVal;
      }
			else if(vars->type == ASN_INTEGER) {				      // 0x02
				value = (double)*vars->val.integer;
      }
    }
  } else {
    /*
    * FAILURE: print what went wrong!
    */

    if (status == STAT_SUCCESS)
      fprintf(stderr, "Error in packet\nReason: %s\n",
      snmp_errstring(response->errstat));
    else
      snmp_sess_perror("snmpget",snmp_sess_session(m_sessp));
    return 0;
  }
  snmp_free_pdu(response);
  return  value;
}


double __stdcall snmpSetDouble(HSNMP m_sessp, const oid* parameter, size_t length, double value) {
  struct snmp_pdu* pdu = snmp_pdu_create(SNMP_MSG_SET);    // prepare set-request pdu
  pdu->community = (u_char*)strdup(writeCommunity);
  pdu->community_len = strlen(writeCommunity);

  // for(each SET request to one crate) {
  float v = (float) value;
  snmp_pdu_add_variable(pdu,parameter,length,ASN_OPAQUE_FLOAT,(u_char*)&v,sizeof(v));
  // } // endfor
  
  value =v;
  struct snmp_pdu* response;
	int status = snmp_sess_synch_response(m_sessp,pdu,&response);

  /*
  * Process the response.
  */
  if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
    /*
    * SUCCESS: Print the result variables
    */
    struct variable_list *vars;
    
    // debug print
    //for(vars = response->variables; vars; vars = vars->next_variable)
    //  print_variable(vars->name, vars->name_length, vars);

    /* manipuate the information ourselves */
    for(vars = response->variables; vars; vars = vars->next_variable) {
			if (vars->type == ASN_OPAQUE_FLOAT) {				    // 0x78
        value = *vars->val.floatVal;
      }
			else if (vars->type == ASN_OPAQUE_DOUBLE) {			// 0x79
        value = *vars->val.doubleVal;
      }
			else if(vars->type == ASN_INTEGER) {				      // 0x02
				value = (double)*vars->val.integer;
      }
	}
  } else {
    /*
    * FAILURE: print what went wrong!
    */

    if (status == STAT_SUCCESS)
      fprintf(stderr, "Error in packet\nReason: %s\n",
      snmp_errstring(response->errstat));
    else
      snmp_sess_perror("snmpget",snmp_sess_session(m_sessp));
    return 0;
  }
  snmp_free_pdu(response);
  return value;
}
