/** Test Program to Demonstrate C-Access to WIENER-Crates via SNMP
first test 04/23/06 running with WIENER_SNMP_LV.dll




*/
#include "stdafx.h"
#include "WIENER_SNMP.h"
#include <iostream>

#include <windows.h>

using namespace std;


char* __stdcall snmpGetString(HSNMP m_sessp, const char *name) {

  size_t length = MAX_OID_LEN;
  oid parameter [MAX_OID_LEN];

  if(!get_node(name,parameter,&length)) {
		syslog(LOG_ERR,"OID %s not found", name); return false;} 

  struct snmp_pdu* pdu = snmp_pdu_create(SNMP_MSG_GET);    // prepare get-request pdu

  // for(each GET request to one crate) {
    snmp_add_null_var(pdu,parameter,length);   // generate request data
  // } // endfor

  struct snmp_pdu* response;
	int status = snmp_sess_synch_response(m_sessp,pdu,&response);
char * sp;
  /*
  * Process the response.
  */
  if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
    /*
    * SUCCESS: Print the result variables
    */
    struct variable_list *vars;
    

    /* manipuate the information ourselves */
    for(vars = response->variables; vars; vars = vars->next_variable) {
	 //if (vars->type == ASN_OCTET_STR) {
	 if (vars->type == ASN_OCTET_STR) {
	   int l=vars->val_len;
	   //cout << "The return length is " << l << endl;
	   sp = new char[1 + vars->val_len];
       memcpy(sp, vars->val.string, vars->val_len);
	   long temp =atoi(sp);
       sp[vars->val_len] = '\0';
     } else
         printf("Value is NOT a string!\n");
     }
     
  } else {
    /*
    * FAILURE: print what went wrong!
    */

    if (status == STAT_SUCCESS)
      fprintf(stderr, "Error in packet\nReason: %s\n",
      snmp_errstring(response->errstat));
    else
      snmp_sess_perror("snmpget",snmp_sess_session(m_sessp));
    return 0;
  }
  snmp_free_pdu(response);
  return  sp;
}




void main(void) {
  if(!SnmpInit()) return;                     // basic init
  HSNMP crate1 = SnmpOpen("192.168.2.80");   // open TCP/IP socket
  if(!crate1) return;
  cout << "-----------------------------------------------------------------\n";
  int channel = 1;
  double value=0;

  int ret=snmpGetInt(crate1, "sysMainSwitch.0");
  cout << "Main Switch is " << ret << endl;

  char* str=snmpGetString(crate1, "outputName.1");
  cout << "Output name for channel 1 is " << str << endl;

  str=snmpGetString(crate1, "fanSerialNumber.0");
  cout << "Fan Tray serial number is " << str << endl;
  
  str=snmpGetString(crate1, "outputStatus.1");
  cout << "SysMainStatus is " << str << endl;

  cout << "\n\n-----------------------------------------------------------------\n";
  SnmpClose(crate1);
  SnmpCleanup();                              // finish

}

