#define EXPORT extern "C" _declspec(dllexport)

#include <net-snmp/net-snmp-config.h>
#define NET_SNMP_SNMPV3_H                   // we don't need SNMPV3 (one include file is missing)
#include <net-snmp/net-snmp-includes.h>

typedef void* HSNMP;   // SNMP handle (like FILE)

const char* readCommunity = "public";       ///< community name for read operations
const char* writeCommunity = "guru";        ///< community name for write operation



// DLL functions

void __stdcall syslog(int priority,const char* format,...);
int __stdcall SnmpInit(void);
void __stdcall SnmpCleanup(void);
HSNMP __stdcall SnmpOpen(const char* ipAddress);
void __stdcall SnmpClose(HSNMP m_sessp);

//Utility Functions
double __stdcall snmpSetDouble(HSNMP m_sessp, const char *name, double value);
double __stdcall snmpGetDouble(HSNMP m_sessp, const char *name);
int __stdcall snmpSetInt(HSNMP m_sessp, const char *name, int value);
int __stdcall snmpGetInt(HSNMP m_sessp, const char *name);

char* __stdcall snmpGetString(HSNMP m_sessp, const char *name);